﻿@page "/login"
@layout LoginLayout
@using Microsoft.AspNetCore.WebUtilities;
@inject IUserService UserService

<PageTitle>JWobot Admin | Login</PageTitle>


<div class="p-5">
    <div class="text-center">
        <h1 class="h4 text-gray-900 mb-4">JWobot Admin!</h1>
    </div>

    <EditForm Model="@loginModel" OnValidSubmit="@ValidateUser" class="user">
        <div class="form-group">
            <input type="email" class="form-control form-control-user"
                   aria-describedby="emailHelp"
                   placeholder="Enter Email Address..." @bind="loginModel.EmailAddress" required>
        </div>
        <div class="form-group">
            <input type="password" class="form-control form-control-user @(!string.IsNullOrEmpty(errMsg) ? "is-invalid": "")"
                   placeholder="Password" @bind="loginModel.Password" required>
            <span class="invalid-feedback text-left" role="alert">
                <strong>@errMsg</strong>
            </span>
        </div>
        <button type="submit" class="btn btn-primary btn-user btn-block">Login</button>
    </EditForm>
    <hr>
    <div class="text-center">
        <a class="small" href="forgot-password.html">Forgot Password?</a>
    </div>
</div>

@code {
    private LoginModel loginModel;
    public string errMsg { get; set; }

    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }

    private User user;

    protected async override Task OnInitializedAsync()
    {
        loginModel = new LoginModel();

        var claimsPrincipal = (await authenticationStateTask).User;

        if (claimsPrincipal.Identity.IsAuthenticated)
        {
            Navigation.NavigateTo("/");
        }
    }

    private async Task<bool> ValidateUser()
    {
        user = UserService.Authenticate(loginModel.EmailAddress, loginModel.Password);

        if (user == null)
        {
            errMsg = "Email address or password is incorrect";
        }
        else
        {
            errMsg = "";
            ((CustomAuthenticationStateProvider)AuthenticationStateProvider).MarkUserAsAuthenticated(user);
            var returnUrl = QueryHelpers.ParseQuery(Navigation.ToAbsoluteUri(Navigation.Uri).Query).GetValueOrDefault("returnurl").ToString();
            if (!string.IsNullOrEmpty(returnUrl))
            {
                Navigation.NavigateTo(returnUrl);
            }
            else
            {
                Navigation.NavigateTo("/");
            }
        }
        return await Task.FromResult(true);

    }
}